com.lowagie.text.pdf

## Class IntHashtable

- java.lang.Object
- - com.lowagie.text.pdf.IntHashtable

- All Implemented Interfaces:
    java.lang.Cloneable

      public class IntHashtable
      extends java.lang.Object
      implements java.lang.Cloneable

  A hash map that uses primitive ints for the key rather than objects.

  Note that this class is for internal optimization purposes only, and may not be supported in future releases of Jakarta Commons Lang. Utilities of this sort may be included in future releases of Jakarta Commons Collections.

  Author:
    Justin Couch, Alex Chaffee (alex@apache.org), Stephen Colebourne, Bruno Lowagie (change Objects as keys into int values), Paulo Soares (added extra methods)

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `(package private) static class` | `IntHashtable.Entry` Innerclass that acts as a datastructure to create a new entry in the table.
    `(package private) static class` | `IntHashtable.IntHashtableIterator`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `private int` | `count` The total number of entries in the hash table.
    `private float` | `loadFactor` The load factor for the hashtable.
    `private IntHashtable.Entry[]` | `table` The hash table data.
    `private int` | `threshold` The table is rehashed when its size exceeds this threshold.

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `IntHashtable()` Constructs a new, empty hashtable with a default capacity and load factor, which is `20` and `0.75` respectively.
    `IntHashtable(int initialCapacity)` Constructs a new, empty hashtable with the specified initial capacity and default load factor, which is `0.75`.
    `IntHashtable(int initialCapacity, float loadFactor)` Constructs a new, empty hashtable with the specified initial capacity and the specified load factor.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `clear()` Clears this hashtable so that it contains no keys.
    `java.lang.Object` | `clone()`
    `boolean` | `contains(int value)` Tests if some key maps into the specified value in this hashtable.
    `boolean` | `containsKey(int key)` Tests if the specified int is a key in this hashtable.
    `boolean` | `containsValue(int value)` Returns `true` if this HashMap maps one or more keys to this value.
    `int` | `get(int key)` Returns the value to which the specified key is mapped in this map.
    `java.util.Iterator` | `getEntryIterator()`
    `int[]` | `getKeys()`
    `int` | `getOneKey()`
    `boolean` | `isEmpty()` Tests if this hashtable maps no keys to values.
    `int` | `put(int key, int value)` Maps the specified `key` to the specified `value` in this hashtable.
    `protected void` | `rehash()` Increases the capacity of and internally reorganizes this hashtable, in order to accommodate and access its entries more efficiently.
    `int` | `remove(int key)` Removes the key (and its corresponding value) from this hashtable.
    `int` | `size()` Returns the number of keys in this hashtable.
    `int[]` | `toOrderedKeys()`

    - ### Methods inherited from class java.lang.Object

      `equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### table

          private transient IntHashtable.Entry[] table

      The hash table data.

    - #### count

          private transient int count

      The total number of entries in the hash table.

    - #### threshold

          private int threshold

      The table is rehashed when its size exceeds this threshold. (The value of this field is (int)(capacity * loadFactor).)

    - #### loadFactor

          private float loadFactor

      The load factor for the hashtable.

  - ### Constructor Detail

    - #### IntHashtable

          public IntHashtable()

      Constructs a new, empty hashtable with a default capacity and load factor, which is `20` and `0.75` respectively.

    - #### IntHashtable

          public IntHashtable(int initialCapacity)

      Constructs a new, empty hashtable with the specified initial capacity and default load factor, which is `0.75`.

      Parameters:
        `initialCapacity` - the initial capacity of the hashtable.
      Throws:
        `java.lang.IllegalArgumentException` - if the initial capacity is less than zero.

    - #### IntHashtable

          public IntHashtable(int initialCapacity,
                      float loadFactor)

      Constructs a new, empty hashtable with the specified initial capacity and the specified load factor.

      Parameters:
        `initialCapacity` - the initial capacity of the hashtable.
        `loadFactor` - the load factor of the hashtable.
      Throws:
        `java.lang.IllegalArgumentException` - if the initial capacity is less than zero, or if the load factor is nonpositive.

  - ### Method Detail

    - #### size

          public int size()

      Returns the number of keys in this hashtable.

      Returns:
        the number of keys in this hashtable.

    - #### isEmpty

          public boolean isEmpty()

      Tests if this hashtable maps no keys to values.

      Returns:
        `true` if this hashtable maps no keys to values; `false` otherwise.

    - #### contains

          public boolean contains(int value)

      Tests if some key maps into the specified value in this hashtable. This operation is more expensive than the `containsKey` method.

      Note that this method is identical in functionality to containsValue, (which is part of the Map interface in the collections framework).

      Parameters:
        `value` - a value to search for.
      Returns:
        `true` if and only if some key maps to the `value` argument in this hashtable as determined by the `equals` method; `false` otherwise.
      Throws:
        `java.lang.NullPointerException` - if the value is `null`.
      See Also:
        `containsKey(int)`, `containsValue(int)`, `Map`

    - #### containsValue

          public boolean containsValue(int value)

      Returns `true` if this HashMap maps one or more keys to this value.

      Note that this method is identical in functionality to contains (which predates the Map interface).

      Parameters:
        `value` - value whose presence in this HashMap is to be tested.
      Returns:
        boolean `true` if the value is contained
      Since:
        JDK1.2
      See Also:
        `Map`

    - #### containsKey

          public boolean containsKey(int key)

      Tests if the specified int is a key in this hashtable.

      Parameters:
        `key` - possible key.
      Returns:
        `true` if and only if the specified int is a key in this hashtable, as determined by the `equals` method; `false` otherwise.
      See Also:
        `contains(int)`

    - #### get

          public int get(int key)

      Returns the value to which the specified key is mapped in this map.

      Parameters:
        `key` - a key in the hashtable.
      Returns:
        the value to which the key is mapped in this hashtable; `null` if the key is not mapped to any value in this hashtable.
      See Also:
        `put(int, int)`

    - #### rehash

          protected void rehash()

      Increases the capacity of and internally reorganizes this hashtable, in order to accommodate and access its entries more efficiently.

      This method is called automatically when the number of keys in the hashtable exceeds this hashtable's capacity and load factor.

    - #### put

          public int put(int key,
                int value)

      Maps the specified `key` to the specified `value` in this hashtable. The key cannot be `null`.

      The value can be retrieved by calling the `get` method with a key that is equal to the original key.

      Parameters:
        `key` - the hashtable key.
        `value` - the value.
      Returns:
        the previous value of the specified key in this hashtable, or `null` if it did not have one.
      Throws:
        `java.lang.NullPointerException` - if the key is `null`.
      See Also:
        `get(int)`

    - #### remove

          public int remove(int key)

      Removes the key (and its corresponding value) from this hashtable.

      This method does nothing if the key is not present in the hashtable.

      Parameters:
        `key` - the key that needs to be removed.
      Returns:
        the value to which the key had been mapped in this hashtable, or `null` if the key did not have a mapping.

    - #### clear

          public void clear()

      Clears this hashtable so that it contains no keys.

    - #### getEntryIterator

          public java.util.Iterator getEntryIterator()

    - #### toOrderedKeys

          public int[] toOrderedKeys()

    - #### getKeys

          public int[] getKeys()

    - #### getOneKey

          public int getOneKey()

    - #### clone

          public java.lang.Object clone()

      Overrides:
        `clone` in class `java.lang.Object`